#ifndef __MAINLIB_H__
#define __MAINLIB_H__

#include <ws/mainlooplib.h>
#include <ws/mainloopmouselib.h>
#include <ws/latentmouselib.h>
#include <ws/fblib.h>
#include <linux/vt.h>


typedef void (*RedrawAll)(FrameBuffer *fb, void *data);

typedef struct
 {
  MainLoop       *loop;
  LatentMouse    *lm;
  FrameBuffer    *fb;
  RedrawAll       redraw;
  void           *redrawData;
  Int             console;
  struct vt_mode  vt_mode;
 } Main;


extern int mainCreate(Main *main, Int consolefd, MainLoop *loop, LatentMouse *lm, FrameBuffer *fb, RedrawAll redraw, void *redrawData);
extern int mainDestroy(Main *main);

#endif /* __MAINLIB_H__ */
