#ifndef __MDISPATCHLIB_H__
#define __MDISPATCHLIB_H__

#include <ws/mouselib.h>
#include <iAVLTree.h>


typedef void (*MDispatchHandler)(Coordinate x, Coordinate y, MouseButtons buttons, void* data);

typedef struct
 {
  long              index;
  Coordinate        x;
  Coordinate        y;
  Size              w;
  Size              h;
  MouseButtons      buttons;
  MouseButtons      mask;
  MDispatchHandler  handler;
  void             *handlerData;
 } MDispatcherEntry;

typedef struct
 {
  long next;
  iAVLTree *items;
 } MDispatcher;


extern void              mdispatcherCreat           (MDispatcher *dispatcher);
extern void              mdispatcherDestroy         (MDispatcher *dispatcher);
extern MDispatcherEntry *mdispatcherAdd             (MDispatcher *dispatcher, Coordinate x, Coordinate y, Size w, Size h, MouseButtons buttons, MouseButtons mask, MDispatchHandler handler, void *handlerData);
extern void              mdispatcherRemove          (MDispatcher *dispatcher, MDispatcherEntry *item);
extern void              mdispatcherTell            (MDispatcher *dispatcher, Coordinate x, Coordinate y, MouseButtons buttons);
extern void              mdispatcherTellMouseHandler(Coordinate position[MOUSE_DIMENSIONS], MouseButtons buttons, void *data);

#endif /* __MDISPATCHLIB_H__ */
